'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = githubRepo;

var _ghGot = require('gh-got');

var _ghGot2 = _interopRequireDefault(_ghGot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function githubRepo(_ref) {
    var token = _ref.token;


    return function () {
        var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref2) {
            var name = _ref2.name;
            var description = _ref2.description;
            var res, data;
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.next = 2;
                            return _ghGot2.default.post('user/repos', {
                                token: token, body: JSON.stringify({ name: name, description: description })
                            });

                        case 2:
                            res = _context.sent;
                            data = res.body;
                            return _context.abrupt('return', {
                                owner: data.owner.login,
                                name: name, description: description,
                                url: data.html_url,
                                upstreamUrl: data.clone_url
                            });

                        case 5:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this);
        }));

        function createRepo(_x) {
            return ref.apply(this, arguments);
        }

        return createRepo;
    }();
}